﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Http;
using System.Web.Mvc;
using System.Web.Routing;

namespace TaskManager
{
    //Класс RouteConfig содержит конфикурацию "маршрутов", показывает как обращатся к контроллерам сервера
    //из клиентской части. Также показывает как обращатся к страницам сайта через адрессную строку браузера.
    public class RouteConfig
    {
        
        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            
            //Показывает как обращатся к контроллерам в Controllers.Api (контроллеры для приема и передачи
            //данных клиенту.
            routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/v1.0/{controller}/{action}/{id}",
                defaults: new { id = System.Web.Http.RouteParameter.Optional }
            );

            //Показвает как обращаться к контроллерам в Controllers (контроллеры для отображения страниц сайта)
            routes.MapRoute(
                name: "Default",
                url: "{controller}/{action}/{id}",
                defaults: new { controller = "Home", action = "Index", id = UrlParameter.Optional }
            );
        }
    }
}