﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using TaskManager.Models.Entities;
using TaskManager.Models.Interfaces.Services;


namespace TaskManager.Models.Services
{
    //UserService - класс который предоставляет набор функций для работы с объектами User в базе данных.
    public class UserService : BaseService<User>, IUserService
    {
        public IQueryable<User> GetAll()
        {
            var users = Repository.Get().ToList();
            return users.AsQueryable();
        }

        public User GetById(int Id)
        {
            return Repository.GetById(Id);
        }

        public void Insert(User addUser)
        {
            Repository.Insert(addUser);
        }

        public void Delete(User delUser)
        {
            Repository.Delete(delUser);
        }
    }
}